package com.biganto.visual.roompark.data.repository.db.requrey

import android.content.Context
import com.biganto.visual.roompark.data.repository.db.IDb
import com.biganto.visual.roompark.data.repository.db.requrey.model.Models
import com.biganto.visual.roompark.data.repository.db.requrey.model.UserEntity
import com.biganto.visual.roompark.di.dagger.DATABASE_VERSION
import dagger.Module
import dagger.Provides
import io.requery.Persistable
import io.requery.android.sqlite.DatabaseSource
import io.requery.reactivex.KotlinReactiveEntityStore
import io.requery.sql.KotlinEntityDataStore
import timber.log.Timber
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 13.06.2018.
 */


@Module
class DbModule{

        @Provides
        fun provideStore(context: Context): KotlinReactiveEntityStore<Persistable> {
                Timber.d("Kotlin store creating..")
                val source = DatabaseSource(context, Models.DEFAULT, "BigantoPerfect", DATABASE_VERSION)

                source.setLoggingEnabled(false)

                val store = KotlinEntityDataStore<Persistable>(source.configuration)
                Timber.d("Kotlin store %s",source)
                return KotlinReactiveEntityStore(store)
        }
}

class RequeryRepository @Inject constructor(
        private val store: KotlinReactiveEntityStore<Persistable>
)
: IDb {

        override fun upsertUser(entity:UserEntity) = store.upsert(entity).toObservable()

}